diff --git a/src/hmacMD5_fmt_plug.c b/src/hmacMD5_fmt_plug.c
index dea0106d36..fd43cc2a45 100644
--- a/src/hmacMD5_fmt_plug.c
+++ b/src/hmacMD5_fmt_plug.c
@@ -510,7 +510,7 @@ static void *get_binary(char *ciphertext)
 			atoi16[ARCH_INDEX(p[1])];
 		p += 2;
 	}
-#if !ARCH_LITTLE_ENDIAN
+#if !ARCH_LITTLE_ENDIAN && defined(SIMD_COEF_32)
 	alter_endianity(out, BINARY_SIZE);
 #endif
 	return (void*)out;
diff --git a/src/mssql12_fmt_plug.c b/src/mssql12_fmt_plug.c
index 655ca45ba2..35f8a29146 100644
--- a/src/mssql12_fmt_plug.c
+++ b/src/mssql12_fmt_plug.c
@@ -368,6 +368,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 	return count;
 }
 
+#define COMMON_GET_HASH_64BIT_HASH
 #define COMMON_GET_HASH_SIMD64 8
 #define COMMON_GET_HASH_VAR crypt_out
 #include "common-get-hash.h"
diff --git a/src/ntlmv1_mschapv2_fmt_plug.c b/src/ntlmv1_mschapv2_fmt_plug.c
index ceaf718000..1f46160f8f 100644
--- a/src/ntlmv1_mschapv2_fmt_plug.c
+++ b/src/ntlmv1_mschapv2_fmt_plug.c
@@ -1210,7 +1210,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 
 static int cmp_one(void *binary, int index)
 {
-#if ARCH_LITTLE_ENDIAN==1
+#if ARCH_LITTLE_ENDIAN==1 || !defined(SIMD_COEF_32)
 	if (crypt_key[index] == *(unsigned short*)binary)
 #else
 	if ( JOHNSWAP(crypt_key[index])>>16 == *(unsigned short*)binary)
@@ -1243,7 +1243,7 @@ static int cmp_one(void *binary, int index)
 
 static int cmp_all(void *binary, int count)
 {
-#if ARCH_LITTLE_ENDIAN==1
+#if ARCH_LITTLE_ENDIAN==1 || !defined(SIMD_COEF_32)
 	unsigned int value = *(unsigned short*)binary;
 #else
 	unsigned int value = JOHNSWAP(*(unsigned short*)binary)>>16;
@@ -1346,7 +1346,7 @@ static int cmp_exact(char *source, int index)
 
 static int salt_hash(void *salt) { return *(uint32_t*)salt & (SALT_HASH_SIZE - 1); }
 
-#if ARCH_LITTLE_ENDIAN==1
+#if ARCH_LITTLE_ENDIAN==1 || !defined(SIMD_COEF_32)
 static int binary_hash_0(void *binary) { return *(unsigned short*)binary & PH_MASK_0; }
 static int binary_hash_1(void *binary) { return *(unsigned short*)binary & PH_MASK_1; }
 static int binary_hash_2(void *binary) { return *(unsigned short*)binary & PH_MASK_2; }
diff --git a/src/ssha512_fmt_plug.c b/src/ssha512_fmt_plug.c
index 77acd37c96..8db5b421e7 100644
--- a/src/ssha512_fmt_plug.c
+++ b/src/ssha512_fmt_plug.c
@@ -245,6 +245,13 @@ static int get_hash_3 (int index) { return crypt_out[(unsigned int)index/SIMD_CO
 static int get_hash_4 (int index) { return crypt_out[(unsigned int)index/SIMD_COEF_64][index&(SIMD_COEF_64-1)] & PH_MASK_4; }
 static int get_hash_5 (int index) { return crypt_out[(unsigned int)index/SIMD_COEF_64][index&(SIMD_COEF_64-1)] & PH_MASK_5; }
 static int get_hash_6 (int index) { return crypt_out[(unsigned int)index/SIMD_COEF_64][index&(SIMD_COEF_64-1)] & PH_MASK_6; }
+static int binary_hash_0 (void *p) { return *((uint64_t*)p) & PH_MASK_0; }
+static int binary_hash_1 (void *p) { return *((uint64_t*)p) & PH_MASK_1; }
+static int binary_hash_2 (void *p) { return *((uint64_t*)p) & PH_MASK_2; }
+static int binary_hash_3 (void *p) { return *((uint64_t*)p) & PH_MASK_3; }
+static int binary_hash_4 (void *p) { return *((uint64_t*)p) & PH_MASK_4; }
+static int binary_hash_5 (void *p) { return *((uint64_t*)p) & PH_MASK_5; }
+static int binary_hash_6 (void *p) { return *((uint64_t*)p) & PH_MASK_6; }
 #else
 static int get_hash_0(int index) { return crypt_out[index][0] & PH_MASK_0; }
 static int get_hash_1(int index) { return crypt_out[index][0] & PH_MASK_1; }
@@ -255,14 +262,6 @@ static int get_hash_5(int index) { return crypt_out[index][0] & PH_MASK_5; }
 static int get_hash_6(int index) { return crypt_out[index][0] & PH_MASK_6; }
 #endif
 
-static int binary_hash_0 (void *p) { return *((uint64_t*)p) & PH_MASK_0; }
-static int binary_hash_1 (void *p) { return *((uint64_t*)p) & PH_MASK_1; }
-static int binary_hash_2 (void *p) { return *((uint64_t*)p) & PH_MASK_2; }
-static int binary_hash_3 (void *p) { return *((uint64_t*)p) & PH_MASK_3; }
-static int binary_hash_4 (void *p) { return *((uint64_t*)p) & PH_MASK_4; }
-static int binary_hash_5 (void *p) { return *((uint64_t*)p) & PH_MASK_5; }
-static int binary_hash_6 (void *p) { return *((uint64_t*)p) & PH_MASK_6; }
-
 static int salt_hash(void *salt)
 {
 	struct s_salt * mysalt = salt;
@@ -300,6 +299,7 @@ struct fmt_main fmt_saltedsha2 = {
 		{ NULL },
 		fmt_default_source,
 		{
+#ifdef SIMD_COEF_64
 			binary_hash_0,
 			binary_hash_1,
 			binary_hash_2,
@@ -307,6 +307,15 @@ struct fmt_main fmt_saltedsha2 = {
 			binary_hash_4,
 			binary_hash_5,
 			binary_hash_6
+#else
+			fmt_default_binary_hash_0,
+			fmt_default_binary_hash_1,
+			fmt_default_binary_hash_2,
+			fmt_default_binary_hash_3,
+			fmt_default_binary_hash_4,
+			fmt_default_binary_hash_5,
+			fmt_default_binary_hash_6
+#endif
 		},
 		salt_hash,
 		NULL,
